#include "sched.h"

#include "process.h"


extern task_struct *user1_pcb;
extern task_struct *init_pcb;
extern task_struct *current;
extern task_struct *cpu_tss;

void schedule(void)
{

	task_struct *prev, *next;
	unsigned int *p_ebp;
	unsigned int *prev_regs;
	unsigned int *regs_in_stack;
	int l;
	unsigned int *next_regs;

	if (current == init_pcb) {
		current = user1_pcb;
		prev = init_pcb;
		next = user1_pcb;
	} else {
		current = init_pcb;
		prev = user1_pcb;
		next = init_pcb;
	}

	asm volatile (
			"mov %%ebp, %0	\n\t"
			: "=m"(p_ebp)
	);
	
	// 
	// ebp+4*15 = CS
	//
	if ( (p_ebp[15] % 0x3) == 0)
		return;

	
	//
	// ebp -> ebp original value
	//        return address of schedule
	// ebp+4*2 -> EDI
	regs_in_stack = p_ebp + 4*2;

	prev_regs = (unsigned int *)&(prev->thread);

	//
	// copy register values in stack to previous process context
	for (l=0; l<17; l++)
		prev_regs[l] = regs_in_stack[l];

	next_regs = (unsigned int *)&(next->thread);
	asm volatile (
		"mov %%ebp, %%esp	\n\t"
		"pop %%ebp			\n\t"
		"add $72, %%esp		\n\t"

		"mov %%esp, %0		\n\t"
		"mov %1, %%esp		\n\t"
		"popal				\n\t"
		"pop %%ds			\n\t"
		"pop %%es			\n\t"
		"pop %%fs			\n\t"
		"pop %%gs			\n\t"
		"iret				\n\t"
		: "=m"(cpu_tss->thread.esp0)
		: "m"(next_regs)
	);
	return;
}
